From 4e50284f0ad3968d7a751bd17129b8669970af7d Mon Sep 17 00:00:00 2001
From: Shugo Maeda <shugo@ruby-lang.org>
Date: Mon, 12 Jul 2010 01:02:26 +0900
Subject: [PATCH 08/51] dup nd_omod.

---
 vm_insnhelper.c |    6 ++----
 1 files changed, 2 insertions(+), 4 deletions(-)

diff --git a/vm_insnhelper.c b/vm_insnhelper.c
index 0fa0d6e..48cb55b 100644
--- a/vm_insnhelper.c
+++ b/vm_insnhelper.c
@@ -1110,11 +1110,9 @@ vm_cref_push(rb_thread_t *th, VALUE klass, int noex, rb_block_t *blockptr)
     else if (cfp) {
 	cref->nd_next = vm_get_cref0(cfp->iseq, cfp->lfp, cfp->dfp);
     }
-#if 0
-    if (cref->nd_next) {
-	cref->nd_omod = cref->nd_next->nd_omod;
+    if (cref->nd_next && !NIL_P(cref->nd_next->nd_omod)) {
+	cref->nd_omod = rb_hash_dup(cref->nd_next->nd_omod);
     }
-#endif
 
     return cref;
 }
-- 
1.7.0.4

